package com.answercenter.networkingadvanced.adapter

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import com.answercenter.networkingadvanced.databinding.RecyclerItemBinding
import com.answercenter.networkingadvanced.models.SearchModel

class SearchAdapter: ListAdapter<SearchModel.Item, SearchAdapter.Holder>(DiffModel()) {
    class DiffModel:DiffUtil.ItemCallback<SearchModel.Item>(){
        override fun areItemsTheSame(
            oldItem: SearchModel.Item,
            newItem: SearchModel.Item
        )= run {
            oldItem.id==newItem.id
        }

        override fun areContentsTheSame(
            oldItem: SearchModel.Item,
            newItem: SearchModel.Item
        ) =run {
            oldItem==newItem
        }

    }
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): Holder {
        val binding=RecyclerItemBinding.inflate(
            LayoutInflater.from(parent.context),parent,false
        )
        return Holder(binding)
    }
    override fun onBindViewHolder(holder: Holder, position: Int) {
       holder.bind(getItem(position))
    }
    class Holder(private val binding: RecyclerItemBinding)
        :RecyclerView.ViewHolder(binding.root){
            fun bind(data:SearchModel.Item){
                binding.fullName.text=data.full_name
                binding.description.text=data.description
                binding.language.text="Language:${data.language}"
            }
        }
}